Subject: Re: untracked file deleted from the master branch, when checked out to it from a local branch

From: Marius Storm-Olsen <[email-masked]>
Date: Tue, 20 May 2014 12:06:49 -0500

On 5/20/2014 11:03 AM, Arup Rakshit wrote:
> On Tuesday, May 20, 2014 11:56:57 AM you wrote:
>> On 5/20/2014 10:38 AM, Arup Rakshit wrote:
>>> I was following some tutorial (http://gitref.org/branching/#merge) - and
>>> doing it in my console :
>
>>
>> Because you never committed the original file to the master branch
>> before you created and switched to the change_class branch.
>>
>> You're missing
>>       git add test.rb
>>       git commit -m "initial version of test.rb"
>> before you switch branches the first time.
>
> Hum, But when I create a new branch from master, then it came to the new
> branch, but deleted from the master. Shouldn't it also not come to the new
> local branch also. That's how I expected.

It never "came to the new branch", as it was never version controlled, 
it was an untracked file left behind when you switched branches.

Once you added it to the new branch, change_class, it became a version 
controlled file, and since you moved to a branch without that file (the 
pristine clean master branch), git removed it. (your version history 
says that change_class contains test.rb and master does not.)

-- 
.marius